-- Sissejuhatus kryptoloogiasse 5. loengu 1. ylesande lahendus

import Numtheory

n = 39029691696331379451654369223
e = 24657264740035
d = 32269175883733667347779391531

-- don't know how to make random numbers in Haskell
-- so I'll play the role of random-number-generator
a=1234

-- if we are lucky with a then b is a nontrivial sqrt(1) mod n
b = modPow n a k
     where k = head (dropWhile bad (iterate (`div`2) t_phi_n))
           bad x = (modPow n a x == 1) || (modPow n a (2*x) /= 1)
           t_phi_n = e * d - 1


p = gcd (b+1) n
q = gcd (b-1) n

test = if p*q == n then "Success" else "Failure"

