import Numtheory

x1 = 12261960808621969430097093975
x2 = 2139929151592762910699647643
x3 = 4422928722515748128164901332

n1 = 28379582766706027776051303889
n2 = 17974669087682550324962819047
n3 = 18045203951154758214214325071

m3 = china [(x1, n1), (x2, n2), (x3, n3)]

m = cubeRoot m3

test 1 = if (m*m*m) == m3 then "Success" else "Failure"
test 2 = if (m3 `mod` n1 == x1) then "Success" else "Failure"
test 3 = if (m3 `mod` n2 == x2) then "Success" else "Failure"
test 4 = if (m3 `mod` n3 == x3) then "Success" else "Failure"

tests = [test i | i <- [1..4]]




-- damn, I don't know how to use ** with integers... :(
-- therefore gotta write custom cube root... 
cubeRoot x = searchRoot 1 (x`div`4)
    where 
       searchRoot a b
           | a == b = a
           | a == (b - 1) = if (b*b*b > x) then a else b
           | otherwise = if (m*m*m < x) then (searchRoot m b) else 
                            (searchRoot a m)
           where m = (a + b) `div` 2

